function [] = recalculateToaGpsAndPlot()
%RECALCULATETOAGPSANDPLOT Summary of this function goes here
%   Detailed explanation goes here

global artoaWorkspace artoaDataInput;

if ~isfield(artoaWorkspace, 'toaData')
    return;
end

%% Recalculate TOAs

% combine initial toa and current applied soundsources
toaData = artoaWorkspace.toaData;
toaData.toa = artoaDataInput.toaData.toa;

if artoaWorkspace.editOffsets.useOffsets
    artoaWorkspace.toaData = artoa.toa.recalculate( ...
        artoaWorkspace.float, ...
        toaData, ...
        artoaWorkspace.editOffsets.offsets ...
    );
    % Add the empirical shift again.
    artoaWorkspace.toaData.toa = artoaWorkspace.toaData.toa + artoaWorkspace.toaData.empiricalShift;
else
    artoaWorkspace.toaData = toaData;
end

%% Calculate GPS TOAs
artoa.controller.edit.timeOfArrival.calculateGpsToas();

%% Update Offsets GUI
artoa.controller.edit.offsets.updateGui();

%% Replot all windows
artoa.controller.edit.updateAvailablePlots();

end

