%% Update the soundspeed method defaults
artoaConfig.defaults.soundspeedMethods = { ...
    'Del Grosso', ...
    'Linear' ...
};
if artoa.data.hasMember(artoaWorkspace, 'trackParameter', 'soundspeedMethodValue')
    artoaWorkspace.trackParameter.soundspeedMethodValue = 1;
end
if artoa.data.hasMember(artoaWorkspace, 'trackParameter', 'soundspeedMethodString')
    artoaWorkspace.trackParameter.soundspeedMethodString = artoaConfig.defaults.soundspeedMethods{artoaWorkspace.trackParameter.soundspeedMethodValue};
end

%% Add soundvelocity options
artoaConfig.defaults.soundvelocityToCopy = { ...
    'Measured', ...
    'Empirical', ...
    'Optimum' ...
};

%% Remove soundspeed table and undo copy value
artoaWorkspace.editOffsets = rmfield(artoaWorkspace.editOffsets, 'undoCopySoundspeed');
artoaWorkspace.editOffsets = rmfield(artoaWorkspace.editOffsets, 'soundspeed');

%% Add variables for soundspeeds to the offsets panel
if artoa.data.hasMember(artoaWorkspace, 'editOffsets', 'offsets')
    % applied
    artoaWorkspace.editOffsets.offsets = ...
        addvars( ...
            artoaWorkspace.editOffsets.offsets, ...
            addNaNCell4284(length(artoaWorkspace.editOffsets.offsets.DateStart)), ...
            'After', 'Drift' ...
            );
	artoaWorkspace.editOffsets.offsets.Properties.VariableNames{6} = 'AppliedSoundspeed';
    % optimum
    artoaWorkspace.editOffsets.offsets = ...
        addvars( ...
            artoaWorkspace.editOffsets.offsets, ...
            addNaNCell4284(length(artoaWorkspace.editOffsets.offsets.DateStart)), ...
            'After', 'Drift' ...
            );
	artoaWorkspace.editOffsets.offsets.Properties.VariableNames{6} = 'OptimumSoundspeed';
    % empirical
    artoaWorkspace.editOffsets.offsets = ...
        addvars( ...
            artoaWorkspace.editOffsets.offsets, ...
            addNaNCell4284(length(artoaWorkspace.editOffsets.offsets.DateStart)), ...
            'After', 'Drift' ...
            );
	artoaWorkspace.editOffsets.offsets.Properties.VariableNames{6} = 'EmpiricalSoundspeed';
    % measured
    artoaWorkspace.editOffsets.offsets = ...
        addvars( ...
            artoaWorkspace.editOffsets.offsets, ...
            addNaNCell4284(length(artoaWorkspace.editOffsets.offsets.DateStart)), ...
            'After', 'Drift' ...
            );
	artoaWorkspace.editOffsets.offsets.Properties.VariableNames{6} = 'MeasuredSoundspeed';
end

%% Remove soundspeed from tracking parameter panel
if artoa.data.hasMember(artoaWorkspace, 'trackParameter', 'soundsourceCombinations')
    artoaWorkspace.trackParameter.soundsourceCombinations(:, 'soundspeed1') = [];
    artoaWorkspace.trackParameter.soundsourceCombinations(:, 'soundspeed2') = [];
    artoaWorkspace.trackParameter.soundsourceCombinations(:, 'soundspeed3') = [];
end

%% Helper functions

function emptyCell = addNaNCell4284(pLength)
    emptyCell = NaN(pLength, 1);
end